diff --git a/MAINTAINERS b/MAINTAINERS
index 9ac4ca180b..cb97fa967f 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -1083,9 +1083,9 @@ F: pc-bios/slof.bin
 F: docs/specs/ppc-spapr-hcalls.txt
 F: docs/specs/ppc-spapr-hotplug.txt
 F: tests/spapr*
-F: tests/libqos/*spapr*
+F: tests/qtest/qos/*spapr*
 F: tests/rtas*
-F: tests/libqos/rtas*
+F: tests/qtest/qos/rtas*
 
 PowerNV (Non-Virtualized)
 M: Cédric Le Goater <clg@kaod.org>
@@ -1328,7 +1328,7 @@ F: hw/block/hd-geometry.c
 F: tests/qtest/ide-test.c
 F: tests/qtest/ahci-test.c
 F: tests/qtest/cdrom-test.c
-F: tests/libqos/ahci*
+F: tests/qtest/qos/ahci*
 T: git https://github.com/jnsnow/qemu.git ide
 
 IPMI
@@ -1724,7 +1724,7 @@ F: hw/nvram/fw_cfg.c
 F: stubs/fw_cfg.c
 F: include/hw/nvram/fw_cfg.h
 F: include/standard-headers/linux/qemu_fw_cfg.h
-F: tests/libqos/fw_cfg.c
+F: tests/qtest/qos/fw_cfg.c
 F: tests/qtest/fw_cfg-test.c
 T: git https://github.com/philmd/qemu.git fw_cfg-next
 
@@ -2085,7 +2085,6 @@ S: Maintained
 F: qtest.c
 F: accel/qtest.c
 F: tests/libqtest*
-F: tests/libqos/
 F: tests/qtest/
 
 Register API
diff --git a/configure b/configure
index 59e7397916..2f0a495dcd 100755
--- a/configure
+++ b/configure
@@ -7928,7 +7928,7 @@ fi
 # tests might fail. Prefer to keep the relevant files in their own
 # directory and symlink the directory instead.
 DIRS="tests tests/tcg tests/tcg/cris tests/tcg/lm32 tests/tcg/xtensa"
-DIRS="$DIRS tests/libqos tests/qtest tests/qapi-schema tests/qemu-iotests"
+DIRS="$DIRS tests/qtest tests/qtest/libqos tests/qapi-schema tests/qemu-iotests"
 DIRS="$DIRS tests/fp tests/vm"
 DIRS="$DIRS docs docs/interop fsdev scsi"
 DIRS="$DIRS pc-bios/optionrom pc-bios/spapr-rtas pc-bios/s390-ccw"
diff --git a/tests/Makefile.include b/tests/Makefile.include
index d68b2d68a8..b1df761932 100644
--- a/tests/Makefile.include
+++ b/tests/Makefile.include
@@ -881,6 +881,6 @@ all: $(QEMU_IOTESTS_HELPERS-y)
 
 -include $(wildcard tests/*.d)
 -include $(wildcard tests/qtest/*.d)
--include $(wildcard tests/libqos/*.d)
+-include $(wildcard tests/qtest/qos/*.d)
 
 endif
diff --git a/tests/qtest/Makefile.include b/tests/qtest/Makefile.include
index 54e1d6fb6c..bf324e8c16 100644
--- a/tests/qtest/Makefile.include
+++ b/tests/qtest/Makefile.include
@@ -145,51 +145,51 @@ check-qtest-s390x-y += cpu-plug-test
 check-qtest-s390x-y += migration-test
 
 # libqos / qgraph :
-libqgraph-obj-y = tests/libqos/qgraph.o
-
-libqos-obj-y = $(libqgraph-obj-y) tests/libqos/pci.o tests/libqos/fw_cfg.o
-libqos-obj-y += tests/libqos/malloc.o
-libqos-obj-y += tests/libqos/libqos.o
-libqos-spapr-obj-y = $(libqos-obj-y) tests/libqos/malloc-spapr.o
-libqos-spapr-obj-y += tests/libqos/libqos-spapr.o
-libqos-spapr-obj-y += tests/libqos/rtas.o
-libqos-spapr-obj-y += tests/libqos/pci-spapr.o
-libqos-pc-obj-y = $(libqos-obj-y) tests/libqos/pci-pc.o
-libqos-pc-obj-y += tests/libqos/malloc-pc.o tests/libqos/libqos-pc.o
-libqos-pc-obj-y += tests/libqos/ahci.o
-libqos-usb-obj-y = $(libqos-spapr-obj-y) $(libqos-pc-obj-y) tests/libqos/usb.o
+libqgraph-obj-y = tests/qtest/libqos/qgraph.o
+
+libqos-obj-y = $(libqgraph-obj-y) tests/qtest/libqos/pci.o tests/qtest/libqos/fw_cfg.o
+libqos-obj-y += tests/qtest/libqos/malloc.o
+libqos-obj-y += tests/qtest/libqos/libqos.o
+libqos-spapr-obj-y = $(libqos-obj-y) tests/qtest/libqos/malloc-spapr.o
+libqos-spapr-obj-y += tests/qtest/libqos/libqos-spapr.o
+libqos-spapr-obj-y += tests/qtest/libqos/rtas.o
+libqos-spapr-obj-y += tests/qtest/libqos/pci-spapr.o
+libqos-pc-obj-y = $(libqos-obj-y) tests/qtest/libqos/pci-pc.o
+libqos-pc-obj-y += tests/qtest/libqos/malloc-pc.o tests/qtest/libqos/libqos-pc.o
+libqos-pc-obj-y += tests/qtest/libqos/ahci.o
+libqos-usb-obj-y = $(libqos-spapr-obj-y) $(libqos-pc-obj-y) tests/qtest/libqos/usb.o
 
 # qos devices:
 qos-test-obj-y = tests/qtest/qos-test.o $(libqgraph-obj-y)
 qos-test-obj-y += $(libqos-pc-obj-y) $(libqos-spapr-obj-y)
-qos-test-obj-y += tests/libqos/e1000e.o
-qos-test-obj-y += tests/libqos/i2c.o
-qos-test-obj-y += tests/libqos/i2c-imx.o
-qos-test-obj-y += tests/libqos/i2c-omap.o
-qos-test-obj-y += tests/libqos/sdhci.o
-qos-test-obj-y += tests/libqos/tpci200.o
-qos-test-obj-y += tests/libqos/virtio.o
-qos-test-obj-$(CONFIG_VIRTFS) += tests/libqos/virtio-9p.o
-qos-test-obj-y += tests/libqos/virtio-balloon.o
-qos-test-obj-y += tests/libqos/virtio-blk.o
-qos-test-obj-y += tests/libqos/virtio-mmio.o
-qos-test-obj-y += tests/libqos/virtio-net.o
-qos-test-obj-y += tests/libqos/virtio-pci.o
-qos-test-obj-y += tests/libqos/virtio-rng.o
-qos-test-obj-y += tests/libqos/virtio-scsi.o
-qos-test-obj-y += tests/libqos/virtio-serial.o
+qos-test-obj-y += tests/qtest/libqos/e1000e.o
+qos-test-obj-y += tests/qtest/libqos/i2c.o
+qos-test-obj-y += tests/qtest/libqos/i2c-imx.o
+qos-test-obj-y += tests/qtest/libqos/i2c-omap.o
+qos-test-obj-y += tests/qtest/libqos/sdhci.o
+qos-test-obj-y += tests/qtest/libqos/tpci200.o
+qos-test-obj-y += tests/qtest/libqos/virtio.o
+qos-test-obj-$(CONFIG_VIRTFS) += tests/qtest/libqos/virtio-9p.o
+qos-test-obj-y += tests/qtest/libqos/virtio-balloon.o
+qos-test-obj-y += tests/qtest/libqos/virtio-blk.o
+qos-test-obj-y += tests/qtest/libqos/virtio-mmio.o
+qos-test-obj-y += tests/qtest/libqos/virtio-net.o
+qos-test-obj-y += tests/qtest/libqos/virtio-pci.o
+qos-test-obj-y += tests/qtest/libqos/virtio-rng.o
+qos-test-obj-y += tests/qtest/libqos/virtio-scsi.o
+qos-test-obj-y += tests/qtest/libqos/virtio-serial.o
 
 # qos machines:
-qos-test-obj-y += tests/libqos/aarch64-xlnx-zcu102-machine.o
-qos-test-obj-y += tests/libqos/arm-imx25-pdk-machine.o
-qos-test-obj-y += tests/libqos/arm-n800-machine.o
-qos-test-obj-y += tests/libqos/arm-raspi2-machine.o
-qos-test-obj-y += tests/libqos/arm-sabrelite-machine.o
-qos-test-obj-y += tests/libqos/arm-smdkc210-machine.o
-qos-test-obj-y += tests/libqos/arm-virt-machine.o
-qos-test-obj-y += tests/libqos/arm-xilinx-zynq-a9-machine.o
-qos-test-obj-y += tests/libqos/ppc64_pseries-machine.o
-qos-test-obj-y += tests/libqos/x86_64_pc-machine.o
+qos-test-obj-y += tests/qtest/libqos/aarch64-xlnx-zcu102-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-imx25-pdk-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-n800-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-raspi2-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-sabrelite-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-smdkc210-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-virt-machine.o
+qos-test-obj-y += tests/qtest/libqos/arm-xilinx-zynq-a9-machine.o
+qos-test-obj-y += tests/qtest/libqos/ppc64_pseries-machine.o
+qos-test-obj-y += tests/qtest/libqos/x86_64_pc-machine.o
 
 # qos tests:
 qos-test-obj-y += tests/qtest/ac97-test.o
diff --git a/tests/libqos/aarch64-xlnx-zcu102-machine.c b/tests/qtest/libqos/aarch64-xlnx-zcu102-machine.c
similarity index 100%
rename from tests/libqos/aarch64-xlnx-zcu102-machine.c
rename to tests/qtest/libqos/aarch64-xlnx-zcu102-machine.c
diff --git a/tests/libqos/ahci.c b/tests/qtest/libqos/ahci.c
similarity index 100%
rename from tests/libqos/ahci.c
rename to tests/qtest/libqos/ahci.c
diff --git a/tests/libqos/ahci.h b/tests/qtest/libqos/ahci.h
similarity index 100%
rename from tests/libqos/ahci.h
rename to tests/qtest/libqos/ahci.h
diff --git a/tests/libqos/arm-imx25-pdk-machine.c b/tests/qtest/libqos/arm-imx25-pdk-machine.c
similarity index 100%
rename from tests/libqos/arm-imx25-pdk-machine.c
rename to tests/qtest/libqos/arm-imx25-pdk-machine.c
diff --git a/tests/libqos/arm-n800-machine.c b/tests/qtest/libqos/arm-n800-machine.c
similarity index 100%
rename from tests/libqos/arm-n800-machine.c
rename to tests/qtest/libqos/arm-n800-machine.c
diff --git a/tests/libqos/arm-raspi2-machine.c b/tests/qtest/libqos/arm-raspi2-machine.c
similarity index 100%
rename from tests/libqos/arm-raspi2-machine.c
rename to tests/qtest/libqos/arm-raspi2-machine.c
diff --git a/tests/libqos/arm-sabrelite-machine.c b/tests/qtest/libqos/arm-sabrelite-machine.c
similarity index 100%
rename from tests/libqos/arm-sabrelite-machine.c
rename to tests/qtest/libqos/arm-sabrelite-machine.c
diff --git a/tests/libqos/arm-smdkc210-machine.c b/tests/qtest/libqos/arm-smdkc210-machine.c
similarity index 100%
rename from tests/libqos/arm-smdkc210-machine.c
rename to tests/qtest/libqos/arm-smdkc210-machine.c
diff --git a/tests/libqos/arm-virt-machine.c b/tests/qtest/libqos/arm-virt-machine.c
similarity index 100%
rename from tests/libqos/arm-virt-machine.c
rename to tests/qtest/libqos/arm-virt-machine.c
diff --git a/tests/libqos/arm-xilinx-zynq-a9-machine.c b/tests/qtest/libqos/arm-xilinx-zynq-a9-machine.c
similarity index 100%
rename from tests/libqos/arm-xilinx-zynq-a9-machine.c
rename to tests/qtest/libqos/arm-xilinx-zynq-a9-machine.c
diff --git a/tests/libqos/e1000e.c b/tests/qtest/libqos/e1000e.c
similarity index 100%
rename from tests/libqos/e1000e.c
rename to tests/qtest/libqos/e1000e.c
diff --git a/tests/libqos/e1000e.h b/tests/qtest/libqos/e1000e.h
similarity index 100%
rename from tests/libqos/e1000e.h
rename to tests/qtest/libqos/e1000e.h
diff --git a/tests/libqos/fw_cfg.c b/tests/qtest/libqos/fw_cfg.c
similarity index 100%
rename from tests/libqos/fw_cfg.c
rename to tests/qtest/libqos/fw_cfg.c
diff --git a/tests/libqos/fw_cfg.h b/tests/qtest/libqos/fw_cfg.h
similarity index 100%
rename from tests/libqos/fw_cfg.h
rename to tests/qtest/libqos/fw_cfg.h
diff --git a/tests/libqos/i2c-imx.c b/tests/qtest/libqos/i2c-imx.c
similarity index 100%
rename from tests/libqos/i2c-imx.c
rename to tests/qtest/libqos/i2c-imx.c
diff --git a/tests/libqos/i2c-omap.c b/tests/qtest/libqos/i2c-omap.c
similarity index 100%
rename from tests/libqos/i2c-omap.c
rename to tests/qtest/libqos/i2c-omap.c
diff --git a/tests/libqos/i2c.c b/tests/qtest/libqos/i2c.c
similarity index 100%
rename from tests/libqos/i2c.c
rename to tests/qtest/libqos/i2c.c
diff --git a/tests/libqos/i2c.h b/tests/qtest/libqos/i2c.h
similarity index 100%
rename from tests/libqos/i2c.h
rename to tests/qtest/libqos/i2c.h
diff --git a/tests/libqos/libqos-pc.c b/tests/qtest/libqos/libqos-pc.c
similarity index 100%
rename from tests/libqos/libqos-pc.c
rename to tests/qtest/libqos/libqos-pc.c
diff --git a/tests/libqos/libqos-pc.h b/tests/qtest/libqos/libqos-pc.h
similarity index 100%
rename from tests/libqos/libqos-pc.h
rename to tests/qtest/libqos/libqos-pc.h
diff --git a/tests/libqos/libqos-spapr.c b/tests/qtest/libqos/libqos-spapr.c
similarity index 100%
rename from tests/libqos/libqos-spapr.c
rename to tests/qtest/libqos/libqos-spapr.c
diff --git a/tests/libqos/libqos-spapr.h b/tests/qtest/libqos/libqos-spapr.h
similarity index 100%
rename from tests/libqos/libqos-spapr.h
rename to tests/qtest/libqos/libqos-spapr.h
diff --git a/tests/libqos/libqos.c b/tests/qtest/libqos/libqos.c
similarity index 100%
rename from tests/libqos/libqos.c
rename to tests/qtest/libqos/libqos.c
diff --git a/tests/libqos/libqos.h b/tests/qtest/libqos/libqos.h
similarity index 100%
rename from tests/libqos/libqos.h
rename to tests/qtest/libqos/libqos.h
diff --git a/tests/libqos/malloc-pc.c b/tests/qtest/libqos/malloc-pc.c
similarity index 100%
rename from tests/libqos/malloc-pc.c
rename to tests/qtest/libqos/malloc-pc.c
diff --git a/tests/libqos/malloc-pc.h b/tests/qtest/libqos/malloc-pc.h
similarity index 100%
rename from tests/libqos/malloc-pc.h
rename to tests/qtest/libqos/malloc-pc.h
diff --git a/tests/libqos/malloc-spapr.c b/tests/qtest/libqos/malloc-spapr.c
similarity index 100%
rename from tests/libqos/malloc-spapr.c
rename to tests/qtest/libqos/malloc-spapr.c
diff --git a/tests/libqos/malloc-spapr.h b/tests/qtest/libqos/malloc-spapr.h
similarity index 100%
rename from tests/libqos/malloc-spapr.h
rename to tests/qtest/libqos/malloc-spapr.h
diff --git a/tests/libqos/malloc.c b/tests/qtest/libqos/malloc.c
similarity index 100%
rename from tests/libqos/malloc.c
rename to tests/qtest/libqos/malloc.c
diff --git a/tests/libqos/malloc.h b/tests/qtest/libqos/malloc.h
similarity index 100%
rename from tests/libqos/malloc.h
rename to tests/qtest/libqos/malloc.h
diff --git a/tests/libqos/pci-pc.c b/tests/qtest/libqos/pci-pc.c
similarity index 100%
rename from tests/libqos/pci-pc.c
rename to tests/qtest/libqos/pci-pc.c
diff --git a/tests/libqos/pci-pc.h b/tests/qtest/libqos/pci-pc.h
similarity index 100%
rename from tests/libqos/pci-pc.h
rename to tests/qtest/libqos/pci-pc.h
diff --git a/tests/libqos/pci-spapr.c b/tests/qtest/libqos/pci-spapr.c
similarity index 100%
rename from tests/libqos/pci-spapr.c
rename to tests/qtest/libqos/pci-spapr.c
diff --git a/tests/libqos/pci-spapr.h b/tests/qtest/libqos/pci-spapr.h
similarity index 100%
rename from tests/libqos/pci-spapr.h
rename to tests/qtest/libqos/pci-spapr.h
diff --git a/tests/libqos/pci.c b/tests/qtest/libqos/pci.c
similarity index 100%
rename from tests/libqos/pci.c
rename to tests/qtest/libqos/pci.c
diff --git a/tests/libqos/pci.h b/tests/qtest/libqos/pci.h
similarity index 100%
rename from tests/libqos/pci.h
rename to tests/qtest/libqos/pci.h
diff --git a/tests/libqos/ppc64_pseries-machine.c b/tests/qtest/libqos/ppc64_pseries-machine.c
similarity index 100%
rename from tests/libqos/ppc64_pseries-machine.c
rename to tests/qtest/libqos/ppc64_pseries-machine.c
diff --git a/tests/libqos/qgraph.c b/tests/qtest/libqos/qgraph.c
similarity index 100%
rename from tests/libqos/qgraph.c
rename to tests/qtest/libqos/qgraph.c
diff --git a/tests/libqos/qgraph.h b/tests/qtest/libqos/qgraph.h
similarity index 100%
rename from tests/libqos/qgraph.h
rename to tests/qtest/libqos/qgraph.h
diff --git a/tests/libqos/qgraph_internal.h b/tests/qtest/libqos/qgraph_internal.h
similarity index 100%
rename from tests/libqos/qgraph_internal.h
rename to tests/qtest/libqos/qgraph_internal.h
diff --git a/tests/libqos/rtas.c b/tests/qtest/libqos/rtas.c
similarity index 100%
rename from tests/libqos/rtas.c
rename to tests/qtest/libqos/rtas.c
diff --git a/tests/libqos/rtas.h b/tests/qtest/libqos/rtas.h
similarity index 100%
rename from tests/libqos/rtas.h
rename to tests/qtest/libqos/rtas.h
diff --git a/tests/libqos/sdhci.c b/tests/qtest/libqos/sdhci.c
similarity index 100%
rename from tests/libqos/sdhci.c
rename to tests/qtest/libqos/sdhci.c
diff --git a/tests/libqos/sdhci.h b/tests/qtest/libqos/sdhci.h
similarity index 100%
rename from tests/libqos/sdhci.h
rename to tests/qtest/libqos/sdhci.h
diff --git a/tests/libqos/tpci200.c b/tests/qtest/libqos/tpci200.c
similarity index 100%
rename from tests/libqos/tpci200.c
rename to tests/qtest/libqos/tpci200.c
diff --git a/tests/libqos/usb.c b/tests/qtest/libqos/usb.c
similarity index 100%
rename from tests/libqos/usb.c
rename to tests/qtest/libqos/usb.c
diff --git a/tests/libqos/usb.h b/tests/qtest/libqos/usb.h
similarity index 100%
rename from tests/libqos/usb.h
rename to tests/qtest/libqos/usb.h
diff --git a/tests/libqos/virtio-9p.c b/tests/qtest/libqos/virtio-9p.c
similarity index 100%
rename from tests/libqos/virtio-9p.c
rename to tests/qtest/libqos/virtio-9p.c
diff --git a/tests/libqos/virtio-9p.h b/tests/qtest/libqos/virtio-9p.h
similarity index 100%
rename from tests/libqos/virtio-9p.h
rename to tests/qtest/libqos/virtio-9p.h
diff --git a/tests/libqos/virtio-balloon.c b/tests/qtest/libqos/virtio-balloon.c
similarity index 100%
rename from tests/libqos/virtio-balloon.c
rename to tests/qtest/libqos/virtio-balloon.c
diff --git a/tests/libqos/virtio-balloon.h b/tests/qtest/libqos/virtio-balloon.h
similarity index 100%
rename from tests/libqos/virtio-balloon.h
rename to tests/qtest/libqos/virtio-balloon.h
diff --git a/tests/libqos/virtio-blk.c b/tests/qtest/libqos/virtio-blk.c
similarity index 100%
rename from tests/libqos/virtio-blk.c
rename to tests/qtest/libqos/virtio-blk.c
diff --git a/tests/libqos/virtio-blk.h b/tests/qtest/libqos/virtio-blk.h
similarity index 100%
rename from tests/libqos/virtio-blk.h
rename to tests/qtest/libqos/virtio-blk.h
diff --git a/tests/libqos/virtio-mmio.c b/tests/qtest/libqos/virtio-mmio.c
similarity index 100%
rename from tests/libqos/virtio-mmio.c
rename to tests/qtest/libqos/virtio-mmio.c
diff --git a/tests/libqos/virtio-mmio.h b/tests/qtest/libqos/virtio-mmio.h
similarity index 100%
rename from tests/libqos/virtio-mmio.h
rename to tests/qtest/libqos/virtio-mmio.h
diff --git a/tests/libqos/virtio-net.c b/tests/qtest/libqos/virtio-net.c
similarity index 100%
rename from tests/libqos/virtio-net.c
rename to tests/qtest/libqos/virtio-net.c
diff --git a/tests/libqos/virtio-net.h b/tests/qtest/libqos/virtio-net.h
similarity index 100%
rename from tests/libqos/virtio-net.h
rename to tests/qtest/libqos/virtio-net.h
diff --git a/tests/libqos/virtio-pci.c b/tests/qtest/libqos/virtio-pci.c
similarity index 100%
rename from tests/libqos/virtio-pci.c
rename to tests/qtest/libqos/virtio-pci.c
diff --git a/tests/libqos/virtio-pci.h b/tests/qtest/libqos/virtio-pci.h
similarity index 100%
rename from tests/libqos/virtio-pci.h
rename to tests/qtest/libqos/virtio-pci.h
diff --git a/tests/libqos/virtio-rng.c b/tests/qtest/libqos/virtio-rng.c
similarity index 100%
rename from tests/libqos/virtio-rng.c
rename to tests/qtest/libqos/virtio-rng.c
diff --git a/tests/libqos/virtio-rng.h b/tests/qtest/libqos/virtio-rng.h
similarity index 100%
rename from tests/libqos/virtio-rng.h
rename to tests/qtest/libqos/virtio-rng.h
diff --git a/tests/libqos/virtio-scsi.c b/tests/qtest/libqos/virtio-scsi.c
similarity index 100%
rename from tests/libqos/virtio-scsi.c
rename to tests/qtest/libqos/virtio-scsi.c
diff --git a/tests/libqos/virtio-scsi.h b/tests/qtest/libqos/virtio-scsi.h
similarity index 100%
rename from tests/libqos/virtio-scsi.h
rename to tests/qtest/libqos/virtio-scsi.h
diff --git a/tests/libqos/virtio-serial.c b/tests/qtest/libqos/virtio-serial.c
similarity index 100%
rename from tests/libqos/virtio-serial.c
rename to tests/qtest/libqos/virtio-serial.c
diff --git a/tests/libqos/virtio-serial.h b/tests/qtest/libqos/virtio-serial.h
similarity index 100%
rename from tests/libqos/virtio-serial.h
rename to tests/qtest/libqos/virtio-serial.h
diff --git a/tests/libqos/virtio.c b/tests/qtest/libqos/virtio.c
similarity index 100%
rename from tests/libqos/virtio.c
rename to tests/qtest/libqos/virtio.c
diff --git a/tests/libqos/virtio.h b/tests/qtest/libqos/virtio.h
similarity index 100%
rename from tests/libqos/virtio.h
rename to tests/qtest/libqos/virtio.h
diff --git a/tests/libqos/x86_64_pc-machine.c b/tests/qtest/libqos/x86_64_pc-machine.c
similarity index 100%
rename from tests/libqos/x86_64_pc-machine.c
rename to tests/qtest/libqos/x86_64_pc-machine.c